
CoCoALib - Bug #389

problem loading library.H (parallel make -j4)

23 Jul 2013 14:24 - Anna Maria Bigatti

Status: Closed Start date: 23 Jul 2013

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: Documentation Estimated time: 0.00 hour

Target version: CoCoALib-0.99531 Spent time: 2.75 hours

Description

I had problems loading library.H in my new installation on linux:

compilation of files including library.H gives

error: '....' was not declared in this scope

AMB: solution: make "library.H" without -j flag, //i.e.// cd include/CoCoA; make

History

#1 - 23 Jul 2013 14:45 - Anna Maria Bigatti

- Category set to Documentation

- Assignee set to Anna Maria Bigatti

- Target version set to CoCoALib-0.99534 Seoul14

Well not all debugging was useless: I cleaned up some .H (yuk ;-) and .C including library.H.  (it makes the compilation slower)

The problem was (and I can imagine JAA laughing at me) that make -j4 (really wonderful on a quad-core!!) creates some copies all mixed up of

library.H in the same file.

I typed

cd include/CoCoA

make

and it goes fine....

JAA: ooohhh!

#2 - 23 Jul 2013 14:47 - Anna Maria Bigatti

- Status changed from New to Feedback

- % Done changed from 0 to 100

#3 - 23 Jul 2013 16:04 - John Abbott

I don't know how to fix this properly -- need help from a Makefile expert.

Workaround: make the unified header file serially, then do the rest in parallel.

26 Apr 2024 1/2



#4 - 23 Jul 2013 17:49 - Anna Maria Bigatti

- Subject changed from problem loading library.H to problem loading library.H (parallel make -j4)

#5 - 24 Jul 2013 14:36 - John Abbott

I have modified the script MakeUnifiedHeader.sh.

It now uses temporary files, so should avoid problems

if several instances are run in parallel.

#6 - 24 Jul 2013 14:51 - Anna Maria Bigatti

I tested it and I didn't manage to create a messy library.H again.

#7 - 11 Sep 2013 16:14 - John Abbott

- Status changed from Feedback to Closed

No problems reported in the last 6 weeks (well, we were all away on holiday).

Closing this issue because it makes me feel that I'm making progress :-)

#8 - 29 Oct 2013 13:07 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99534 Seoul14 to CoCoALib-0.99532

#9 - 29 Oct 2013 13:31 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99532 to CoCoALib-0.99531
